import * as Minecraft from "@minecraft/server"

//Made by NK

Minecraft.world.beforeEvents.itemUse.subscribe(({ itemStack, source }) => {
    if ((itemStack.typeId == "minecraft:compass") ||
        (itemStack.typeId == "minecraft:clock") ||
        (itemStack.typeId == "minecraft:nautilus_shell")) {
        source.runCommandAsync(`tag @s add itemUse:${itemStack.typeId}`)
        if (itemStack.nameTag) try { source.addTag(`itemUseName:${itemStack.nameTag}`) } catch (err) { console.error(err) }

        Minecraft.system.runTimeout(() => {
            source.runCommandAsync(`tag @s remove itemUse:${itemStack.typeId}`)
            source.runCommandAsync(`tag @s remove itemUseName:${itemStack.nameTag}`)
        })
    }
})

Minecraft.world.beforeEvents.itemUseOn.subscribe(({ itemStack, source }) => {
    if ((itemStack.typeId == "minecraft:compass") ||
        (itemStack.typeId == "minecraft:clock") ||
        (itemStack.typeId == "minecraft:nautilus_shell")) {
        source.runCommandAsync(`tag @s add itemUseOn:${itemStack.typeId}`)
        if (itemStack.nameTag) source.addTag(`itemUseName:${itemStack.nameTag}`)

        Minecraft.system.runTimeout(() => {
            source.runCommandAsync(`tag @s remove itemUseOn:${itemStack.typeId}`)
            source.runCommandAsync(`tag @s remove itemUseName:${itemStack.nameTag}`)
        })
    }
})
